package com.ether;

public class Pair<V1, V2>
{
    public Pair()
    {
        this( null, null );
    }

    public Pair( final V1 firstValue,
                 final V2 secondValue )
    {
        _firstValue = firstValue;
        _secondValue = secondValue;
    }

    public final V1 getFirstValue()
    {
        return _firstValue;
    }

    public final void setFirstValue( final V1 firstValue )
    {
        _firstValue = firstValue;
    }

    public V2 getSecondValue()
    {
        return _secondValue;
    }

    public void setSecondValue( final V2 secondValue )
    {
        _secondValue = secondValue;
    }

    public String toString()
    {
        return String.format( "<%s,%s>", _firstValue, _secondValue );
    }

    public boolean equals( final Object o )
    {
        if( this == o ) return true;
        if( !( o instanceof Pair ) ) return false;

        final Pair pair = (Pair) o;

        if( _firstValue != null ? !_firstValue.equals( pair._firstValue ) : pair._firstValue != null ) return false;
        if( _secondValue != null ? !_secondValue.equals( pair._secondValue ) : pair._secondValue != null ) return false;

        return true;
    }

    public int hashCode()
    {
        int result;
        result = ( _firstValue != null ? _firstValue.hashCode() : 0 );
        result = 31 * result + ( _secondValue != null ? _secondValue.hashCode() : 0 );
        return result;
    }

    private V1 _firstValue;
    private V2 _secondValue;
}
